////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   : : "    Delphi "
//  * Unit Name : anti_dump_demo.dpr
//  * Purpose   :        
//  * Author    :  (Rouse_) 
//  * Copyright :  Fangorn Wizards Lab 1998 - 2016.
//  * Version   : 1.0.0
//  * Home Page : http://rouse.drkb.ru
//  * Home Blog : http://alexander-bagel.blogspot.ru
//  ****************************************************************************
//  * Article   : http://alexander-bagel.blogspot.ru/2016/03/early-execution.html
//  ****************************************************************************
//

program anti_dump_demo;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  Windows;

var
  //   
  anti_dump_mark: DWORD = 0;

const
  //  ,    
  valid_anti_dump_mark_value = $DEADBEEF;

//    ,     
procedure tls_callback(hModule: HMODULE;
  ul_reason_for_call: DWORD; lpReserved: Pointer); stdcall;
begin
  if ul_reason_for_call = DLL_PROCESS_ATTACH then
  begin
    //   -         
    if anti_dump_mark = 0 then
      //    -  .
      //       
      anti_dump_mark := valid_anti_dump_mark_value
    else
      //        -   
      //    ,      
      anti_dump_mark := 1;
  end;
end;

const
  ptls_callback: Pointer = @tls_callback;

begin
  //  -       ,   ?
  //    -      valid_anti_dump_mark_value
  if anti_dump_mark <> valid_anti_dump_mark_value then
  begin
    //     -  "" 
    //       :
    // 1.    TLS Callback (   )
    // 2.  -   :)
    MessageBox(0, 'Process dumped', nil, 0);
    //    ,   ;)
    TerminateProcess(GetCurrentProcess, 0);
  end;
  //   tls_callback   MAP 
  //      ,   :
  if ptls_callback <> nil then
    MessageBox(0, 'All done', nil, 0);
end.
