////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   : : "    Delphi "
//  * Unit Name : test_app.dpr
//  * Purpose   :    TLS Callback
//  * Author    :  (Rouse_) 
//  * Copyright :  Fangorn Wizards Lab 1998 - 2016.
//  * Version   : 1.0.0
//  * Home Page : http://rouse.drkb.ru
//  * Home Blog : http://alexander-bagel.blogspot.ru
//  ****************************************************************************
//  * Article   : http://alexander-bagel.blogspot.ru/2016/03/early-execution.html
//  ****************************************************************************
//

program test_app;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  Windows;

//    ,     
procedure tls_callback(hModule: HMODULE;
  ul_reason_for_call: DWORD; lpReserved: Pointer); stdcall;
begin
  if ul_reason_for_call = DLL_PROCESS_ATTACH then
    MessageBox(0, 'TLS Callback Message', nil, 0);
end;

const
  ptls_callback: Pointer = @tls_callback;

begin
  //   tls_callback   MAP 
  //      ,   :
  if ptls_callback <> nil then
    MessageBox(0, 'Entry Point Message', nil, 0);
end.
